chiark / gitweb /
backgrounds: Add two more for the collection.
[profile] / setup
CommitLineData
65ff0e8c 1#! /bin/bash
f617db13
MW
2
3set -e
4
ce178f96
MW
5###--------------------------------------------------------------------------
6### Basic setup.
7
f617db13
MW
8umask 002
9
4aa875e9 10sub=
f617db13
MW
11mkdir -p $HOME$sub
12
8ba15f37 13: ${REPO=http://ftp.distorted.org.uk/ftp/pub/mdw/profile}
f617db13
MW
14
15export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
ce178f96
MW
17###--------------------------------------------------------------------------
18### Sort out command line.
19
f617db13
MW
20xstuff= false=
21while [ $# -gt 0 ]; do
22 case "$1" in
23 -x) xstuff=t;;
24 -n) false=false;;
25 --) shift; break;;
26 -*) echo >&2 "$0: bad option"; exit 1;;
27 *) break;;
28 esac
29 shift
30done
31
ce178f96
MW
32###--------------------------------------------------------------------------
33### Environment autoconfiguration.
34
35## Find out where I am
f617db13 36here=$(pwd)
f617db13 37
ce178f96 38## Suss out how to print things
f617db13
MW
39out=$(echo -n "foo"; echo "bar")
40if [ "$out" = "foobar" ]; then
41 echon="echo -n"
42 echoc=""
43else
44 echon="echo"
45 echoc='\c'
46fi
47
ce178f96 48## Find out how to fetch things over the net
f617db13
MW
49$echon "Finding URL fetcher:$echoc"
50if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51 GETURL="curl -fs -o"
52 echo " curl."
53elif wget >/dev/null 2>&1 --version; then
54 GETURL="wget -q -O"
55 echo " wget."
56else
57 echo " failed!"
58 echo >&2 "$0: failed to find URL fetcher"
59 exit 1
60fi
61
ce178f96
MW
62###--------------------------------------------------------------------------
63### Create the necessary directories.
64
65echo "Creating directories..."
66for i in bin lib/emacs src; do
67 $echon " $i:$echoc"
68 if [ -d $HOME$sub/$i ]; then
69 echo " already exists."
70 else
71 mkdir -p $HOME$sub/$i
72 echo " done."
73 fi
74done
75echo " all done."
76
ce178f96
MW
77###--------------------------------------------------------------------------
78### Install some more complicated programs.
79
f617db13
MW
80echo "Installing packages..."
81systems="
285a1386
MW
82 mlib:crc-mktab
83 checkpath:tmpdir
f617db13
MW
84"
85[ "$xstuff" ] && systems="$systems
285a1386 86 xtoys:xatom
f617db13
MW
87"
88for system in $systems; do
89 set -- $(echo $system | tr : ' ')
285a1386 90 sys=$1 prog=$2
f617db13
MW
91 $echon " $sys:$echoc"
92 if $false $prog >/dev/null 2>&1 --version; then
93 echo " already installed."
94 else
95 ( set -e
96 $echon " downloading$echoc"
97 cd $HOME$sub/src
285a1386
MW
98 rm -rf $sys.tar.gz $sys-$ver
99 $GETURL $sys.tar.gz $REPO/$sys.tar.gz
f617db13 100 $echon " unpacking$echoc"
285a1386
MW
101 dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102 gzip -cd $sys.tar.gz | tar xf -
f617db13 103 $echon " configuring$echoc"
285a1386 104 cd $dir
f617db13
MW
105 mkdir build
106 cd build
107 ../configure --prefix=$HOME$sub >>buildlog 2>&1
108 $echon " building$echoc"
109 make >>buildlog 2>&1
110 $echon " installing$echoc"
111 make install >>buildlog 2>&1
112 echo " done."
113 )
114 fi
115done
852cd5fb 116echo " all done."
f617db13 117
ce178f96
MW
118###--------------------------------------------------------------------------
119### Install global configuration.
120
f141fe0f
MW
121echo -n "Installing dotfile configuration:"
122if [ -f $HOME$sub/.mdw.conf ]; then
123 echo " already installed."
124else
125 cp mdw.conf $HOME$sub/.mdw.conf
126 echo " done."
127fi
128
ce178f96 129## Symlink the various dotfiles into place
852cd5fb 130dotfiles="
be7dba95 131 bash_profile bash_logout bashrc inputrc bash_completion
a3bdb4d9 132 emacs emacs-calc vm gnus.el
b0d8acbe 133 vimrc mg zile
b3468c3b 134 mailrc signature
ce178f96 135 cgrc tigrc
e7d23024 136 gdbinit
8a7e906d 137 guile
5d25e440 138 toprc
cbffcf2b 139 aspell.conf
ccaac00b
MW
140 lisp-init.lisp:.cmucl-init.lisp
141 lisp-init.lisp:.sbclrc
142 lisp-init.lisp:.clisprc.lisp
f6335a0c 143 lisp-init.lisp:.eclrc
b5bf3445 144 swank.lisp
2425eca9 145 dircolors colordiffrc screenrc cvsrc indent.pro"
739bccbf 146[ "$xstuff" ] && dotfiles="$dotfiles
eae29a8c 147 xinitrc xsession Xdefaults vncrc vncsession
5e23020b 148 fonts.conf
1c6b19d4 149 putty-defaults:.putty/sessions/Default%20Settings
7cfa1f1a 150 eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
739bccbf 151 e-keybindings.cfg:.enlightenment/keybindings.cfg
eae29a8c 152 evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
f4e43257 153 e16-bindings:.e16/bindings.cfg"
f617db13
MW
154echo "Installing dotfiles..."
155for d in $dotfiles; do
739bccbf
MW
156 target=.$d
157 case $d in
158 *:*) target=${d#*:} d=${d%%:*};;
159 esac
160 ft=$HOME$sub/$target
161 dir=${ft%/*}
162 mkdir -p $dir
163 ln -s $here/$d $ft.new
164 mv $ft.new $ft
165 echo " $target"
f617db13 166done
852cd5fb 167echo " all done."
f617db13 168
f4e43257
MW
169## Symlink backgrounds.
170backgrounds="jue-peek.jpg medusa.jpg rayne.jpg"
171if [ "$xstuff" ]; then
172 echo "Installing backgrounds..."
173 for b in $backgrounds; do
174 for e in enlightenment e16; do
175 dir=$HOME$sub/.$e/backgrounds
176 t=$dir/$b
177 mkdir -p $dir
178 ln -s $here/$b $t.new
179 mv $t.new $t
180 done
181 echo " $b"
182 done
183 echo " all done."
184fi
185
ce178f96
MW
186###--------------------------------------------------------------------------
187### Process the Git configuration.
188
189echo -n "Installing Git configuration:"
190sed "
1911i\
15581433 192### generated by $here/setup; do not edit!\
ce178f96
MW
193
194/@releasekey@/ s::$(./mdw-conf release-key 481334C2):g
15581433 195/@gitignore@/ s::$(./mdw-conf gitignore $here/gitignore):g
ce178f96
MW
196" gitconfig >$HOME/.gitconfig.new
197mv $HOME/.gitconfig.new $HOME/.gitconfig
198echo " done."
199
200###--------------------------------------------------------------------------
201### Install useful scripts included in this package.
202
e04c4857 203scripts="
547fb8af 204 mdw-editor
b20bfd83 205 mdw-pager
b056f5c4 206 mdw-conf
7ee12623 207 mdw-build
8e08f814 208 movemail-hack
285a1386
MW
209 emerge-hack
210 lesspipe.sh
211 start-ssh-agent
4cdeb0d0
MW
212 svnwrap
213 hyperspec"
8e08f814 214[ "$xstuff" ] && scripts="$scripts
3bdada49 215 xinitcmd
34a5ea4e 216 un-backslashify-selection
8e08f814 217 xshutdown"
e04c4857
MW
218echo "Installing scripts..."
219mkdir -p $HOME$sub/bin
220for s in $scripts; do
221 ft=$HOME$sub/bin/$s
222 ln -s $here/$s $ft.new
223 mv $ft.new $ft
224 echo " $s"
225done
226echo " all done."
227
ce178f96
MW
228###--------------------------------------------------------------------------
229### Set up the Emacs config.
230
65ff0e8c
MW
231$echon "Finding a suitable emacs:$echoc"
232emacs=no
6960aa99 233for i in emacs22 emacs21 emacs; do
65ff0e8c
MW
234 if type -p >/dev/null $i; then
235 emacs=$i
236 break
237 fi
238done
239if [ $emacs = no ]; then
240 echo " failed."
241 emacs=:
242else
243 echo " $emacs."
244fi
245
f617db13 246echo "Installing Emacs packages..."
400223a1
MW
247emacspkg="
248 make-regexp
a1293ade 249 ew-hols
a3bdb4d9 250 mdw-gnus-patch
1778b496 251 git git-blame vc-git stgit
400223a1
MW
252 quilt"
253for elib in $emacspkg; do
f617db13 254 $echon " $elib:$echoc"
65ff0e8c 255 if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
20eb0692 256 (progn
852cd5fb
MW
257 (setq load-path (nconc load-path (list "~/lib/emacs")))
258 (kill-emacs (condition-case nil
259 (progn (load-library "'"$elib"'") 0)
20eb0692 260 (error 1))))'; then
f617db13
MW
261 echo " already installed."
262 else
a3bdb4d9
MW
263 if [ -f $elib.el ]; then
264 cp $elib.el $HOME$sub/lib/emacs/$elib.el
265 else
266 $echon " downloading$echoc"
267 $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
268 fi
f617db13
MW
269 $echon " compiling$echoc"
270 (cd $HOME$sub/lib/emacs;
65ff0e8c 271 $emacs >/dev/null 2>&1 --no-site-file --batch \
20eb0692 272 --eval '(byte-compile-file "'"$elib.el"'")')
f617db13
MW
273 echo " done."
274 fi
275done
852cd5fb 276echo " all done."
f617db13
MW
277
278$echon "Setting up Emacs configuration:$echoc"
279$echon " linking$echoc"
280for link in dot-emacs.el:dot-emacs.el emacs-Makefile:Makefile; do
281 set -- $(echo $link | tr : ' ')
282 from=$1 to=$2
739bccbf
MW
283 ln -s $here/$from $HOME$sub/lib/emacs/$to.new
284 mv $HOME$sub/lib/emacs/$to.new $HOME$sub/lib/emacs/$to
f617db13
MW
285done
286$echon " compiling$echoc"
65ff0e8c 287make >/dev/null 2>&1 -C $HOME$sub/lib/emacs EMACS=$emacs
f617db13 288echo " done."
ce178f96
MW
289
290###----- That's all, folks --------------------------------------------------